//+------------------------------------------------------------------+
//|                                                 System MA 20.mq4 |
//|                                                           Pokman |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Pokman"
#property link      ""
#include <WinUser32.mqh>
#include <stderror.mqh>
#include <stdlib.mqh>

//---- input parameters
extern int       PT1=110;
extern int       PT2=0;
extern int       SLBE=0;
extern int       SL=50;
extern double    Lots=0.1;
extern int       MA=20;
extern int       Risk=0;
extern bool      SmerMA=false;
extern bool      PatekNE=false;
extern bool      MultiLot=False;

int faze,povol,sprd1,minlot,minsl,Sident,Bident;
string sname;
double sprd2,kredit,sclose,sopen;
bool stat=true;
datetime tbar;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
 int nn;
 if (!stat) return(0);
 sprd1=MarketInfo(Symbol(),MODE_SPREAD); // spread
 sname=Symbol(); // jmno instrumentu
 sprd2=sprd1*Point; // spread pepotan na cenu 
 minsl=MarketInfo(sname,MODE_STOPLEVEL); // minimln odstup
 minlot=MarketInfo(sname,MODE_MINLOT);// minimalni objem
 kredit=AccountBalance();
 povol=0;
 faze=0;
 // kontrola clov ceny
if (PT1<minsl) {nn=MessageBox("ProfitTarget mus bt nejmn "+minsl+" bod.","Zadan profit je pli nzk !",MB_OK);povol=1;}
if (PT2>0 && PT2<=PT1) {nn=MessageBox("PT2 mus bt vt ne PT1 !","Opravte prosm !",MB_OK);povol=1;}
if (PT2>0 && Lots<minlot*2) {nn=MessageBox("Je-li nastaveno PT2, mus bt Lots nejmn "+DoubleToStr(minlot*2,2)+" bod.","Opravte prosm !",MB_OK);povol=1;}
// kontrola velikosti lotu
if (Lots<minlot) {nn=MessageBox("Minimln objem je "+DoubleToStr(minlot,2)+
 " lotu.","Nesprvn velikost lotu !",MB_OK);povol=1;}
if (Risk>0) Lots=((AccountBalance()/(100/Risk))/SL)/MarketInfo(sname,MODE_TICKVALUE);// vypocitej objem dle Risku %
if (Risk>0 && PT2>0 && Lots<minlot*2) {nn=MessageBox("Pi nastaven PT2 je nutn objem alespo "+DoubleToStr(minlot*2,2)+" bod. Risk "+Risk+" %, dv objem jen "+Lots,"Nemohu obchodovat !",MB_OK);povol=1;} 
// kontrola stoplossu
if ( SL<minsl) {nn=MessageBox("Minimln odstup StopLossu je "+minsl,"Odstup Stoplossu je men ne je dovoleno !",MB_OK);povol=1;}
if ( SLBE>0 && SLBE<minsl) {nn=MessageBox("Minimln odstup StopLossu je "+minsl,"Odstup SLBE je men ne je dovoleno !",MB_OK);povol=1;}

// kontrola pokyn
if (OrdersTotal()>0) for(int j=0;j<OrdersTotal();j++)
 {
 OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
 if (OrderSymbol()==sname) {nn=MessageBox("Ukonete obchody a zrute ekac pokyny.","Na tomto instrumentu jsou ji zadny pokyny !",MB_OK);povol=1;}
 }

if (MarketInfo("EURUSD",MODE_DIGITS)==5) {PT1=PT1*10;PT2=PT2*10;SL=SL*10;SLBE=SLBE*10;}
if (povol==1) Comment("\n----- Nesprvn parametry -----\n !!!!! POKYN NELZE USKUTENIT !!!!!");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 int nn,ee;
 double sma=iMA(sname,PERIOD_H4,MA,0,MODE_SMA,PRICE_CLOSE,1); // hodnota MA na ukoncene svici H4
 double profit;
 if (povol==1) {Comment("\n----- Nesprvn parametry -----\n !!!!! POKYN NELZE USKUTENIT !!!!!");return(0);}
 stat=false;ee=0;
 if (PT2>0) profit=PT2; else profit=PT1;
 if (PatekNE && DayOfWeek()==5 && Hour()>=21)// je patek po 21.00 h
  {
   if (OrdersTotal()>0) for(nn=0;nn<OrdersTotal();nn++)
   {
    OrderSelect(nn, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()==sname) 
     {
      if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,2); // v patek vecer ukonci vsechny obchody
      if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,2);
     }
   }
   return(0);
  }

 if (OrdersTotal()>0) for(nn=0;nn<OrdersTotal();nn++)
   {
    OrderSelect(nn, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()==sname)
     {
      if (OrderType()==OP_BUY) Bident=OrderTicket(); // zskej cisla otevrenych obchodu
      if (OrderType()==OP_SELL) Sident=OrderTicket();
      ee=1;
     } 
   }
 if (ee==0) {faze=0;if (tbar==iTime(sname,PERIOD_H4,1)) return(0);}// pokud nebyla dokreslena nova svice, nepokracuj
 if (Risk==0 && MultiLot && AccountBalance()>(kredit*2)) {Lots=Lots*2;kredit=AccountBalance();} // navys objem - MultiLot je True
 if (Risk>0) Lots=NormalizeDouble(((AccountBalance()/(100/Risk))/SL)/MarketInfo(sname,MODE_TICKVALUE),1);// vypocitej objem dle Risku %
// ee=MathPow(10,Digits);
 sclose=iClose(sname,PERIOD_H4,1);
 sopen=iOpen(sname,PERIOD_H4,1);
 if (faze==0 || faze==2)// nejsem-li v zadnem obchode nebo jsem Short
   if (sopen<sma-(5*Point) && sclose>sma+(5*Point)) // protnuti MA do Long
    {
     if (SmerMA && sma<iMA(sname,PERIOD_H4,MA,0,MODE_SMA,PRICE_CLOSE,2)) return(0); // jen ve smeru MA
     if (PatekNE && DayOfWeek()==5)  {OrderSelect(Sident,SELECT_BY_TICKET);OrderClose(Sident,OrderLots(),Ask,2);return(0);}// v patek neobchoduj - PatekNE je true
     Bident=OrderSend(sname,OP_BUY,Lots,Ask,1,Ask-(SL*Point),Ask+(profit*Point),"Trader1 nakoupil ...",123); // vstup za market
     OrderSelect(Sident,SELECT_BY_TICKET);OrderClose(Sident,OrderLots(),Ask,2); // ukonci Short pozici pokud existuje
     tbar=iTime(sname,PERIOD_H4,1);// cas sig.svice
     faze=1;return(0);
    }
 if (faze==0 || faze==1)// nejsem-li v zadnem obchode nebo jsem Long
   if (sopen>sma+(5*Point) && sclose<sma-(5*Point)) // protnuti MA do Short
    {
     if (SmerMA && sma>iMA(sname,PERIOD_H4,MA,0,MODE_SMA,PRICE_CLOSE,2)) return(0); // jen ve smeru MA
     if (PatekNE && DayOfWeek()==5) {OrderSelect(Bident,SELECT_BY_TICKET);OrderClose(Bident,OrderLots(),Bid,2);return(0);}// je patek
     Sident=OrderSend(sname,OP_SELL,Lots,Bid,1,Bid+(SL*Point),Bid-(profit*Point),"Trader1 nakoupil ...",123);
     OrderSelect(Bident,SELECT_BY_TICKET);OrderClose(Bident,OrderLots(),Bid,2); // ukonci Long pozici pokud existuje
     tbar=iTime(sname,PERIOD_H4,1);//cas sig.svice
     faze=2;return(0);
    }
 // dohled nad SL na BE a PT1/PT2
 if (faze==1) // jsem LONG
  {
   OrderSelect(Bident,SELECT_BY_TICKET);
   if (SLBE>0 && OrderStopLoss()!=OrderOpenPrice() && Ask>=OrderOpenPrice()+(SLBE*Point)) OrderModify(Bident,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);// SL na BE
   if (PT2>0 && OrderStopLoss()!=OrderOpenPrice() && Ask>=OrderOpenPrice()+(PT1*Point)) {OrderModify(Bident,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
     OrderClose(Bident,NormalizeDouble(OrderLots()/2,1),Bid,1);}// presun SL na BE a ukonci polovinu na PT1
  }
 if (faze==2) // jsem SHORT
  {
   OrderSelect(Sident,SELECT_BY_TICKET);
   if (SLBE>0 && OrderStopLoss()!=OrderOpenPrice() && Bid<=OrderOpenPrice()-(SLBE*Point)) OrderModify(Sident,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);// SL na BE
   if (PT2>0 && OrderStopLoss()!=OrderOpenPrice() && Bid<=OrderOpenPrice()-(PT1*Point)) {OrderModify(Sident,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
     OrderClose(Sident,NormalizeDouble(OrderLots()/2,1),Ask,1);}// presun SL na BE a ukonci polovinu na PT1
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+